/*
 * (C) Copyright 2009-2016 ECMWF.
 * 
 * This software is licensed under the terms of the Apache Licence Version 2.0
 * which can be obtained at http://www.apache.org/licenses/LICENSE-2.0. 
 * In applying this licence, ECMWF does not waive the privileges and immunities 
 * granted to it by virtue of its status as an intergovernmental organisation nor
 * does it submit to any jurisdiction.
 */

#ifndef LORENZ95_HORIZSCALEDECOMPOSITIONL95_H_
#define LORENZ95_HORIZSCALEDECOMPOSITIONL95_H_

#include <memory> // for std::unique_ptr
#include <ostream>
#include <string>

#include "eckit/config/Configuration.h"
#include "eckit/memory/NonCopyable.h"

#include "util/DateTime.h"
#include "util/ObjectCounter.h"
#include "util/Printable.h"

// Forward declarations
namespace lorenz95 {
  class IncrementL95;

/// HorizScaleDecomposition matrix for lorenz95 model.

// -----------------------------------------------------------------------------
class HorizScaleDecompositionL95: public util::Printable,
                            private eckit::NonCopyable,
                            private util::ObjectCounter<HorizScaleDecompositionL95> {
 public:
    HorizScaleDecompositionL95(const eckit::Configuration &){}

    void collect(const IncrementL95 &, const int &) const{}
    void decompose(const IncrementL95 &, const int &) const{}

    static const std::string classname() {return "lorenz95::HorizScaleDecompositionL95";}

 private:
    void print(std::ostream & os) const {os << "HorizScaleDecompositionL95::print not implemented";}
  //F90interp keyFtnConfig_;
};
// -----------------------------------------------------------------------------

}  // namespace lorenz95

#endif  // LORENZ95_HORIZSCALEDECOMPOSITIONL95_H_
