/*
 * (C) Copyright 2009-2016 ECMWF.
 * 
 * This software is licensed under the terms of the Apache Licence Version 2.0
 * which can be obtained at http://www.apache.org/licenses/LICENSE-2.0. 
 * In applying this licence, ECMWF does not waive the privileges and immunities 
 * granted to it by virtue of its status as an intergovernmental organisation nor
 * does it submit to any jurisdiction.
 */

#include "lorenz95/InterpolatorL95.h"

#include "lorenz95/NoVariables.h"
#include "lorenz95/Resolution.h"
#include "lorenz95/IncrementL95.h"
#include "lorenz95/StateL95.h"

// -----------------------------------------------------------------------------
namespace lorenz95 {
// -----------------------------------------------------------------------------
void InterpolatorL95::interpolate(const IncrementL95 & dxin,
    const NoVariables & vars, IncrementL95 & dxout) const {
  dxout = dxin;
}

// -----------------------------------------------------------------------------
void InterpolatorL95::interpolate(const StateL95 & xin, const NoVariables & vars,
    StateL95 & xout) const {
  xout = xin;
}

// -----------------------------------------------------------------------------
void InterpolatorL95::print(std::ostream & os) const {
  os << "InterpolatorL95::print not implemented";
}

// -----------------------------------------------------------------------------

}  // namespace lorenz95
