#ifndef L95_MODELBIASESTIMATOR_H_
#define L95_MODELBIASESTIMATOR_H_

#include <iostream>
#include <string>

#include "util/ObjectCounter.h"
#include "util/Printable.h"

namespace eckit {
  class Configuration;
}

namespace lorenz95 {
  class Resolution;
  class ModelL95;
  class ModelBias;
  class StateL95;

/// Model error neural network model for the L95 model.
/*!
 * This class is ..
 */

// -----------------------------------------------------------------------------

class ModelBiasEstimator : public util::Printable,
                           private eckit::NonCopyable,
                           private util::ObjectCounter<ModelBiasEstimator> {
 public:
  static const std::string classname() {return "qg::ModelBiasEstimator";}

/// Constructors, destructors
  ModelBiasEstimator(const Resolution &,
                     const ModelL95 &,
                     const eckit::Configuration &) {}
  ~ModelBiasEstimator() {}

/// Methods
  void estimate(const StateL95 &, ModelBias &) const {}
  void estimate(const StateL95 &, const StateL95 &, ModelBias &) const {}

 private:
  void print(std::ostream & os) const {}
};

// -----------------------------------------------------------------------------

}  // namespace lorenz95

#endif  // L95_MODELBIASESTIMATOR_H_
