/*
 * (C) Copyright 2009-2016 ECMWF.
 * 
 * This software is licensed under the terms of the Apache Licence Version 2.0
 * which can be obtained at http://www.apache.org/licenses/LICENSE-2.0. 
 * In applying this licence, ECMWF does not waive the privileges and immunities 
 * granted to it by virtue of its status as an intergovernmental organisation nor
 * does it submit to any jurisdiction.
 */

#ifndef QG_MODEL_HORIZSCALEDECOMPOSITIONQG_H_
#define QG_MODEL_HORIZSCALEDECOMPOSITIONQG_H_

#include <memory> // for std::unique_ptr
#include <ostream>
#include <string>

#include "eckit/config/Configuration.h"
#include "eckit/memory/NonCopyable.h"

#include "util/DateTime.h"
#include "util/ObjectCounter.h"
#include "util/Printable.h"

#include "model/QgFortran.h"

// Forward declarations
namespace qg {
  class IncrementQG;

/// HorizScaleDecomposition matrix for QG model.

// -----------------------------------------------------------------------------
class HorizScaleDecompositionQG: public util::Printable,
                            private eckit::NonCopyable,
                            private util::ObjectCounter<HorizScaleDecompositionQG> {
 public:
    HorizScaleDecompositionQG(const eckit::Configuration &){}

    void collect(const IncrementQG &, const int &) const{}
    void decompose(const IncrementQG &, const int &) const{}

    static const std::string classname() {return "qg::HorizScaleDecompositionQG";}

 private:
    void print(std::ostream & os) const {os << "HorizScaleDecompositionQG::print not implemented";}
  //F90interp keyFtnConfig_;
};
// -----------------------------------------------------------------------------

}  // namespace qg

#endif  // QG_MODEL_HORIZSCALEDECOMPOSITIONQG_H_
