/*
 * (C) Copyright 2009-2016 ECMWF.
 * 
 * This software is licensed under the terms of the Apache Licence Version 2.0
 * which can be obtained at http://www.apache.org/licenses/LICENSE-2.0. 
 * In applying this licence, ECMWF does not waive the privileges and immunities 
 * granted to it by virtue of its status as an intergovernmental organisation nor
 * does it submit to any jurisdiction.
 */

#include "model/InterpolatorQG.h"

#include "model/VariablesQG.h"
#include "model/GeometryQG.h"
#include "model/IncrementQG.h"
#include "model/StateQG.h"

// -----------------------------------------------------------------------------
namespace qg {
// -----------------------------------------------------------------------------
void InterpolatorQG::interpolate(const IncrementQG & dxin,
    const VariablesQG & vars, IncrementQG & dxout) const {
  dxout = dxin;
}

// -----------------------------------------------------------------------------
void InterpolatorQG::interpolate(const StateQG & xin, const VariablesQG & vars,
    StateQG & xout) const {
  xout = xin;
}

// -----------------------------------------------------------------------------
void InterpolatorQG::print(std::ostream & os) const {
  os << "InterpolatorQG::print not implemented";
}

// -----------------------------------------------------------------------------

}  // namespace qg
