#ifndef QG_MODELBIASESTIMATOR_H_
#define QG_MODELBIASESTIMATOR_H_

#include <iostream>
#include <string>

#include "util/ObjectCounter.h"
#include "util/Printable.h"

namespace eckit {
  class Configuration;
}

namespace qg {
  class GeometryQG;
  class ModelQG;
  class ModelBias;
  class StateQG;

/// Model error neural network model for the QG model.
/*!
 * This class is ..
 */

// -----------------------------------------------------------------------------

class ModelBiasEstimator : public util::Printable,
                             private eckit::NonCopyable,
                             private util::ObjectCounter<ModelBiasEstimator> {
 public:
  static const std::string classname() {return "qg::ModelBiasEstimator";}

/// Constructors, destructors
  ModelBiasEstimator(const GeometryQG &,
                     const ModelQG &,
                     const eckit::Configuration &) {}
  ~ModelBiasEstimator() {}

/// Methods
  void estimate(const StateQG &, ModelBias &) const {}
  void estimate(const StateQG &, const StateQG &, ModelBias &) const {}

 private:
  void print(std::ostream & os) const {}
};

// -----------------------------------------------------------------------------

}  // namespace qg

#endif  // QG_MODELBIASESTIMATOR_H_
