/*
 * (C) Copyright 2009-2016 ECMWF.
 * 
 * This software is licensed under the terms of the Apache Licence Version 2.0
 * which can be obtained at http://www.apache.org/licenses/LICENSE-2.0. 
 * In applying this licence, ECMWF does not waive the privileges and immunities 
 * granted to it by virtue of its status as an intergovernmental organisation nor
 * does it submit to any jurisdiction.
 */

#include "model/VariablesQG.h"

#include <iostream>

#include "eckit/exception/Exceptions.h"

#include "model/QgFortran.h"

// -----------------------------------------------------------------------------
namespace qg {
// -----------------------------------------------------------------------------

std::vector<std::string> VariablesQG::variablesList() const {
  int nv;
  int nl;
  qg_var_info_f90(keyVar_, nv, nl);
  std::vector<std::string> variablesList;
  if (nv == 1) {
    if (nl == 1) {
      variablesList = {"x_nl"};
    } else {
      variablesList = {"x"};
    }
  } else {
    if (nl == 1) {
      variablesList = {"x_nl","q_nl","u_nl","v_nl"};
    } else {
      variablesList = {"x","q","u","v"};
    }
  }
  return variablesList;
} 

// -----------------------------------------------------------------------------

void VariablesQG::print(std::ostream & os) const {
  int nv;
  int nl;
  qg_var_info_f90(keyVar_, nv, nl);
  os << nv;
  if (nl == 1) os << " with LBC";
  ASSERT(nl == 0 || nl == 1);
}

// -----------------------------------------------------------------------------

}  // namespace qg
