! test_keras_from_Massimo.f90

! TO RUN
! ./test_keras_from_Massimo $NF_PATH/ExampleModels/simple_model.txt

! print result

program test_keras_from_Massimo
  use mod_kinds, only: ik, rk
  use mod_network, only: network_type

  implicit none

  type(network_type) :: net

  real(rk), allocatable :: output_1D(:), input_1D(:)
  real(rk), allocatable :: output(:,:), input(:,:)
  integer :: j
  integer :: nx, ny
  character(len=100), dimension(:), allocatable :: args

  allocate(args(1))
  call get_command_argument(1,args(1))

  ! load trained network from keras
  call net%load(args(1))
  WRITE(*,*) 'NETWORK LOADED'
  WRITE(*,*) ' input size:   net%input_size = ', net%input_size
  WRITE(*,*) ' output size: net%output_size = ', net%output_size

  ! allocate memory
  nx=280
  ny=3528
  if (net%input_size /= nx) WRITE(*,*) 'WRONG INPUT SIZE'
  allocate(input(net%input_size,ny))
  allocate(output(net%output_size,ny))

  ! load input
  OPEN(33, FILE="input.bin",&
           form="unformatted", status="unknown", action="read", access='stream')
  read(33) input
  close(33)

  ! Loop over all the profiles
  do j=1,ny
    ! get single col input
    input_1D = input(:,j)

    ! run test input through network
    output_1D = net%output(input_1D)

    if (j == 1) then
      write(*,*) 'input='
      write(*,*) input_1D(1:10)
      write(*,*) 'output='
      write(*,*) output_1D(1:10)
    end if

    ! reshape output
    output(:,j) = output_1D(:)
  end do

  ! write output
  open(35, file="output.bin",&
           form="unformatted", status="unknown", action="write", access='stream')
  write(35) output
  close(35)

end program test_keras_from_Massimo
