/*
 * (C) Copyright 2009-2016 ECMWF.
 *
 * This software is licensed under the terms of the Apache Licence Version 2.0
 * which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
 * In applying this licence, ECMWF does not waive the privileges and immunities
 * granted to it by virtue of its status as an intergovernmental organisation
 * nor
 * does it submit to any jurisdiction.
 */

#ifndef OOPS_BASE_INSTANTIATEPOSTPROCESSORSTATEFACTORY_H_
#define OOPS_BASE_INSTANTIATEPOSTPROCESSORSTATEFACTORY_H_

#include "oops/base/ObserverIAU.h"
#include "oops/base/PostProcessorFactory.h"
#include "oops/base/StateInfo.h"
#include "oops/base/StateWriter.h"
#include "oops/interface/PostProcessorModel.h"
#include "oops/interface/State.h"

namespace oops {

template <typename MODEL>
void instantiatePostProcessorStateFactory() {
  static PostProcessorMaker<MODEL, State<MODEL>, StateInfo<State<MODEL> > >
      makerStateInfo__("state_info");
  static PostProcessorMaker<MODEL, State<MODEL>, StateWriter<State<MODEL> > >
      makerStateWriter_("state_writer");
  static PostProcessorMaker<MODEL, State<MODEL>,
                            ObserverIAU<MODEL, State<MODEL> > >
      makerIAU_("IAU");
}

}  // namespace oops

#endif  // OOPS_BASE_INSTANTIATEPOSTPROCESSORSTATEFACTORY_H_
