/*
 * (C) Copyright 2009-2016 ECMWF.
 *
 * This software is licensed under the terms of the Apache Licence Version 2.0
 * which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
 * In applying this licence, ECMWF does not waive the privileges and immunities
 * granted to it by virtue of its status as an intergovernmental organisation
 * nor does it submit to any jurisdiction.
 */

#ifndef OOPS_RUNS_RUN_H_
#define OOPS_RUNS_RUN_H_

#include <memory>  // for std::unique_ptr

#include "eckit/config/YAMLConfiguration.h"
#include "eckit/log/LogTarget.h"
#include "eckit/runtime/Main.h"
#include "util/Timer.h"

namespace oops {
class Application;

/*!
 *  Run encapsulates one OOPS run.
 */

// -----------------------------------------------------------------------------

class Run : public eckit::Main {
 public:
  Run(int argc, char** argv);
  virtual ~Run();
  virtual void execute(const Application&);

 protected:
  const eckit::Configuration& config() const { return *config_; }
  eckit::LogTarget* createInfoLogTarget() const override;

 private:
  std::unique_ptr<const eckit::YAMLConfiguration> config_;
  std::unique_ptr<util::Timer> timer_;
};

// -----------------------------------------------------------------------------

}  // namespace oops
#endif  // OOPS_RUNS_RUN_H_
