/*
 * (C) Copyright 2009-2016 ECMWF.
 *
 * This software is licensed under the terms of the Apache Licence Version 2.0
 * which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
 * In applying this licence, ECMWF does not waive the privileges and immunities
 * granted to it by virtue of its status as an intergovernmental organisation
 * nor does it submit to any jurisdiction.
 */

#ifndef UTIL_MALLOCTRIM_H_
#define UTIL_MALLOCTRIM_H_

#ifdef __GLIBC__
#include <malloc.h>
#endif

namespace util {

// -----------------------------------------------------------------------------

int MallocTrim(const size_t& pad) {
  int status = 0;
#ifdef __GLIBC__
  status = malloc_trim(pad);
#endif
  return status;
}

// -----------------------------------------------------------------------------

}  // namespace util

#endif  // UTIL_MALLOCTRIM_H_
